package cn.ibizlab.humanresource.core.humanresource.service.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.Map;
import java.util.HashSet;
import java.util.HashMap;
import java.util.Collection;
import java.util.Objects;
import java.util.Optional;
import java.math.BigInteger;

import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.ObjectUtils;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.context.annotation.Lazy;
import cn.ibizlab.humanresource.core.humanresource.domain.HRDutySkill;
import cn.ibizlab.humanresource.core.humanresource.filter.HRDutySkillSearchContext;
import cn.ibizlab.humanresource.core.humanresource.service.IHRDutySkillService;

import cn.ibizlab.humanresource.util.helper.CachedBeanCopier;
import cn.ibizlab.humanresource.util.helper.DEFieldCacheMap;


import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import cn.ibizlab.humanresource.core.humanresource.mapper.HRDutySkillMapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.alibaba.fastjson.JSONObject;
import org.springframework.util.StringUtils;

/**
 * 实体[职务技能] 服务对象接口实现
 */
@Slf4j
@Service("HRDutySkillServiceImpl")
public class HRDutySkillServiceImpl extends ServiceImpl<HRDutySkillMapper, HRDutySkill> implements IHRDutySkillService {

    @Autowired
    @Lazy
    protected cn.ibizlab.humanresource.core.humanresource.service.IHRDutyService hrdutyService;

    protected int batchSize = 500;

    @Override
    @Transactional
    public boolean create(HRDutySkill et) {
        if(!this.retBool(this.baseMapper.insert(et)))
            return false;
        CachedBeanCopier.copy(get(et.getHrdutyskillid()),et);
        return true;
    }

    @Override
    public void createBatch(List<HRDutySkill> list) {
        this.saveBatch(list,batchSize);
    }

    @Override
    @Transactional
    public boolean update(HRDutySkill et) {
        if(!update(et,(Wrapper) et.getUpdateWrapper(true).eq("hrdutyskillid",et.getHrdutyskillid())))
            return false;
        CachedBeanCopier.copy(get(et.getHrdutyskillid()),et);
        return true;
    }

    @Override
    public void updateBatch(List<HRDutySkill> list) {
        updateBatchById(list,batchSize);
    }

    @Override
    @Transactional
    public boolean remove(String key) {
        boolean result=removeById(key);
        return result ;
    }

    @Override
    public void removeBatch(Collection<String> idList) {
        removeByIds(idList);
    }

    @Override
    @Transactional
    public HRDutySkill get(String key) {
        HRDutySkill et = getById(key);
        if(et==null){
            et=new HRDutySkill();
            et.setHrdutyskillid(key);
        }
        else{
        }
        return et;
    }

    @Override
    public HRDutySkill getDraft(HRDutySkill et) {
        return et;
    }

    @Override
    public boolean checkKey(HRDutySkill et) {
        return (!ObjectUtils.isEmpty(et.getHrdutyskillid()))&&(!Objects.isNull(this.getById(et.getHrdutyskillid())));
    }
    @Override
    @Transactional
    public boolean save(HRDutySkill et) {
        if(!saveOrUpdate(et))
            return false;
        return true;
    }

    @Override
    @Transactional
    public boolean saveOrUpdate(HRDutySkill et) {
        if (null == et) {
            return false;
        } else {
            return checkKey(et) ? this.update(et) : this.create(et);
        }
    }

    @Override
    public boolean saveBatch(Collection<HRDutySkill> list) {
        saveOrUpdateBatch(list,batchSize);
        return true;
    }

    @Override
    public void saveBatch(List<HRDutySkill> list) {
        saveOrUpdateBatch(list,batchSize);
    }


	@Override
    public List<HRDutySkill> selectByHrdutyid(String hrdutyid) {
        return baseMapper.selectByHrdutyid(hrdutyid);
    }

    @Override
    public void removeByHrdutyid(String hrdutyid) {
        this.remove(new QueryWrapper<HRDutySkill>().eq("hrdutyid",hrdutyid));
    }


    /**
     * 查询集合 DEFAULT
     */
    @Override
    public Page<HRDutySkill> searchDefault(HRDutySkillSearchContext context) {
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<HRDutySkill> pages=baseMapper.searchDefault(context.getPages(),context,context.getSelectCond());
        return new PageImpl<HRDutySkill>(pages.getRecords(), context.getPageable(), pages.getTotal());
    }







    @Override
    public List<JSONObject> select(String sql, Map param){
        return this.baseMapper.selectBySQL(sql,param);
    }

    @Override
    @Transactional
    public boolean execute(String sql , Map param){
        if (sql == null || sql.isEmpty()) {
            return false;
        }
        if (sql.toLowerCase().trim().startsWith("insert")) {
            return this.baseMapper.insertBySQL(sql,param);
        }
        if (sql.toLowerCase().trim().startsWith("update")) {
            return this.baseMapper.updateBySQL(sql,param);
        }
        if (sql.toLowerCase().trim().startsWith("delete")) {
            return this.baseMapper.deleteBySQL(sql,param);
        }
        log.warn("暂未支持的SQL语法");
        return true;
    }

    @Override
    public List<HRDutySkill> getHrdutyskillByIds(List<String> ids) {
         return this.listByIds(ids);
    }

    @Override
    public List<HRDutySkill> getHrdutyskillByEntities(List<HRDutySkill> entities) {
        List ids =new ArrayList();
        for(HRDutySkill entity : entities){
            Serializable id=entity.getHrdutyskillid();
            if(!ObjectUtils.isEmpty(id)){
                ids.add(id);
            }
        }
        if(ids.size()>0)
           return this.listByIds(ids);
        else
           return entities;
    }

}



